"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Prefetcher = Prefetcher;
exports.INTENTION_DELAY_MS = void 0;

var _react = _interopRequireDefault(require("react"));

var _prefetch = require("./context/prefetch.js");

var _EventListener = require("./EventListener.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var INTENTION_DELAY_MS = 150;
exports.INTENTION_DELAY_MS = INTENTION_DELAY_MS;

var ConnectedPrefetcher = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(ConnectedPrefetcher, _React$PureComponent);

  var _super = _createSuper(ConnectedPrefetcher);

  function ConnectedPrefetcher() {
    var _this;

    _classCallCheck(this, ConnectedPrefetcher);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {};
    _this.timeout = void 0;
    _this.timeoutUrl = void 0;
    _this.prefetchAgressively = shouldPrefetchAggressively();

    _this.handlePressStart = function (_ref) {
      var target = _ref.target;

      _this.clearTimeout();

      if (target == null) {
        return;
      }

      var url = closestUrlFromNode(target);

      if (url != null) {
        _this.setState({
          url: url
        });
      }
    };

    _this.handlePointerLeave = function (_ref2) {
      var target = _ref2.target,
          relatedTarget = _ref2.relatedTarget;
      var url = _this.state.url;

      var _assertThisInitialize = _assertThisInitialized(_this),
          timeout = _assertThisInitialize.timeout,
          timeoutUrl = _assertThisInitialize.timeoutUrl;

      if (target == null) {
        if (timeout) {
          _this.clearTimeout();
        }

        return;
      }

      if (url == null && timeout == null) {
        return;
      }

      var closestUrl = closestUrlFromNode(target);
      var relatedUrl = relatedTarget && closestUrlFromNode(relatedTarget);

      if (timeout != null && urlsEqual(closestUrl, timeoutUrl) && !urlsEqual(relatedUrl, timeoutUrl)) {
        _this.clearTimeout();
      }

      if (urlsEqual(closestUrl, url) && !urlsEqual(relatedUrl, url)) {
        _this.setState({
          url: undefined
        });
      }
    };

    _this.handlePointerEnter = function (_ref3) {
      var target = _ref3.target;

      if (target == null) {
        return;
      }

      var _assertThisInitialize2 = _assertThisInitialized(_this),
          timeoutUrl = _assertThisInitialize2.timeoutUrl,
          timeout = _assertThisInitialize2.timeout;

      var url = closestUrlFromNode(target);

      if (url == null) {
        return;
      }

      if (timeout) {
        if (urlsEqual(url, timeoutUrl)) {
          return;
        } else {
          _this.clearTimeout();
        }
      }

      _this.timeoutUrl = url;
      _this.timeout = setTimeout(function () {
        _this.clearTimeout();

        _this.setState({
          url: url
        });
      }, INTENTION_DELAY_MS);
    };

    return _this;
  }

  _createClass(ConnectedPrefetcher, [{
    key: "render",
    value: function render() {
      var url = this.state.url;
      var manager = this.props.manager;
      var preloadMarkup = url ? /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          visibility: 'hidden'
        }
      }, findMatches(manager.registered, url).map(function (_ref4, index) {
        var render = _ref4.render,
            path = _ref4.path;
        // eslint-disable-next-line react/no-array-index-key
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: "".concat(path).concat(index)
        }, render(url));
      })) : null;
      var expensiveListeners = this.prefetchAgressively ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_EventListener.EventListener, {
        passive: true,
        event: "mouseover",
        handler: this.handlePointerEnter
      }), /*#__PURE__*/_react["default"].createElement(_EventListener.EventListener, {
        passive: true,
        event: "focusin",
        handler: this.handlePointerEnter
      }), /*#__PURE__*/_react["default"].createElement(_EventListener.EventListener, {
        passive: true,
        event: "mouseout",
        handler: this.handlePointerLeave
      }), /*#__PURE__*/_react["default"].createElement(_EventListener.EventListener, {
        passive: true,
        event: "focusout",
        handler: this.handlePointerLeave
      })) : null;
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_EventListener.EventListener, {
        passive: true,
        event: "mousedown",
        handler: this.handlePressStart
      }), /*#__PURE__*/_react["default"].createElement(_EventListener.EventListener, {
        passive: true,
        event: "touchstart",
        handler: this.handlePressStart
      }), expensiveListeners, preloadMarkup);
    }
  }, {
    key: "clearTimeout",
    value: function (_clearTimeout) {
      function clearTimeout() {
        return _clearTimeout.apply(this, arguments);
      }

      clearTimeout.toString = function () {
        return _clearTimeout.toString();
      };

      return clearTimeout;
    }(function () {
      if (this.timeout != null) {
        clearTimeout(this.timeout);
        this.timeout = undefined;
        this.timeoutUrl = undefined;
      }
    })
  }]);

  return ConnectedPrefetcher;
}(_react["default"].PureComponent);

function Prefetcher(props) {
  return /*#__PURE__*/_react["default"].createElement(_prefetch.PrefetchContext.Consumer, null, function (manager) {
    return /*#__PURE__*/_react["default"].createElement(ConnectedPrefetcher, Object.assign({}, props, {
      manager: manager
    }));
  });
}

function shouldPrefetchAggressively() {
  return typeof navigator === 'undefined' || !('connection' in navigator) || !navigator.connection.saveData;
}

function urlsEqual(first, second) {
  return first == null && first === second || first != null && second != null && first.href === second.href;
}

function findMatches(records, url) {
  return _toConsumableArray(records).filter(function (_ref5) {
    var match = _ref5.path;
    return matches(url, match);
  });
}

function matches(url, matcher) {
  return typeof matcher === 'string' ? matcher === url.pathname : matcher.test(url.pathname);
}

function closestUrlFromNode(element) {
  if (!(element instanceof HTMLElement)) {
    return undefined;
  } // data-href is a hack for resource list doing the <a> as a sibling


  var closestUrl = element.closest('[href], [data-href]');

  if (closestUrl == null || !(closestUrl instanceof HTMLElement)) {
    return undefined;
  }

  var url = closestUrl.getAttribute('href') || closestUrl.getAttribute('data-href');

  try {
    return url ? new URL(url, window.location.href) : undefined;
  } catch (error) {
    return undefined;
  }
}