import React from 'react';
// see https://github.com/oliviertassinari/react-event-listener/
export class EventListener extends React.PureComponent {
    componentDidMount() {
        this.attachListener();
    }
    componentDidUpdate(_a) {
        var { passive } = _a, detachProps = __rest(_a, ["passive"]);
        this.detachListener(detachProps);
        this.attachListener();
    }
    componentWillUnmount() {
        this.detachListener();
    }
    render() {
        return null;
    }
    attachListener() {
        const { event, handler, capture, passive } = this.props;
        window.addEventListener(event, handler, { capture, passive });
    }
    detachListener(prevProps) {
        const { event, handler, capture } = prevProps || this.props;
        window.removeEventListener(event, handler, capture);
    }
}
